<!-- This comment will put IE 6, 7 and 8 in quirks mode -->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<title>The m17n Library: input.c File Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javaScript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css"/>
</head>
<body onload='searchBox.OnSelectItem(0);'>
<!-- Generated by Doxygen 1.6.3 -->
<script type="text/javascript"><!--
var searchBox = new SearchBox("searchBox", "search",false,'Search');
--></script>
<div class="navigation" id="top">
  <div class="tabs">
    <ul>
      <li><a href="index.html"><span>Main&nbsp;Page</span></a></li>
      <li><a href="pages.html"><span>Related&nbsp;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="annotated.html"><span>Data&nbsp;Structures</span></a></li>
      <li class="current"><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <img id="MSearchSelect" src="search/search.png"
             onmouseover="return searchBox.OnSearchSelectShow()"
             onmouseout="return searchBox.OnSearchSelectHide()"
             alt=""/>
        <input type="text" id="MSearchField" value="Search" accesskey="S"
             onfocus="searchBox.OnSearchFieldFocus(true)" 
             onblur="searchBox.OnSearchFieldFocus(false)" 
             onkeyup="searchBox.OnSearchFieldChange(event)"/>
        <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
        </div>
      </li>
    </ul>
  </div>
  <div class="tabs">
    <ul>
      <li><a href="files.html"><span>File&nbsp;List</span></a></li>
      <li><a href="globals.html"><span>Globals</span></a></li>
    </ul>
  </div>
</div>
<div class="contents">
<h1>input.c File Reference</h1><table border="0" cellpadding="0" cellspacing="0">
<tr><td colspan="2"><h2>Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structMInputMethod.html">MInputMethod</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nDebug.html#ga8844c814bf108e3c614ffb41ba810f3c">mdebug_dump_im</a> (<a class="el" href="structMInputMethod.html">MInputMethod</a> *im, int indent)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Dump an input method.  <a href="group__m17nDebug.html#ga8844c814bf108e3c614ffb41ba810f3c"></a><br/></td></tr>
<tr><td colspan="2"><div class="groupHeader">Functions</div></td></tr>
<tr><td colspan="2"><div class="groupText"><p><a class="anchor" id="amgrpe93acb146e114b5dfa6ce2d12dcb96e4"></a> </p>
</div></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structMInputMethod.html">MInputMethod</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga34d3e527bfd705d2b7f2b749199c1e11">minput_open_im</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> name, void *arg)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Open an input method.  <a href="group__m17nInputMethod.html#ga34d3e527bfd705d2b7f2b749199c1e11"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga373b415d157c2507f4ca4a864836e905">minput_close_im</a> (<a class="el" href="structMInputMethod.html">MInputMethod</a> *im)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Close an input method.  <a href="group__m17nInputMethod.html#ga373b415d157c2507f4ca4a864836e905"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structMInputContext.html">MInputContext</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga8b32df84c645f73ed65e20a1d51c1859">minput_create_ic</a> (<a class="el" href="structMInputMethod.html">MInputMethod</a> *im, void *arg)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Create an input context.  <a href="group__m17nInputMethod.html#ga8b32df84c645f73ed65e20a1d51c1859"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga80e4b330fb112883f2183d54b4e9c5bb">minput_destroy_ic</a> (<a class="el" href="structMInputContext.html">MInputContext</a> *ic)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Destroy an input context.  <a href="group__m17nInputMethod.html#ga80e4b330fb112883f2183d54b4e9c5bb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga6d9c3c97524114496fd8b7f70af92457">minput_filter</a> (<a class="el" href="structMInputContext.html">MInputContext</a> *ic, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *arg)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Filter an input key.  <a href="group__m17nInputMethod.html#ga6d9c3c97524114496fd8b7f70af92457"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gafe533480c705b877189938a0eecb1b57">minput_lookup</a> (<a class="el" href="structMInputContext.html">MInputContext</a> *ic, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> key, void *arg, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Look up a text produced in the input context.  <a href="group__m17nInputMethod.html#gafe533480c705b877189938a0eecb1b57"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gac12030bd2d5c265a7327a9487f9c1376">minput_set_spot</a> (<a class="el" href="structMInputContext.html">MInputContext</a> *ic, int x, int y, int ascent, int descent, int fontsize, <a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *mt, int pos)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the spot of the input context.  <a href="group__m17nInputMethod.html#gac12030bd2d5c265a7327a9487f9c1376"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga065a8f8e5a28180fd0fa6d160e07481b">minput_toggle</a> (<a class="el" href="structMInputContext.html">MInputContext</a> *ic)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Toggle input method.  <a href="group__m17nInputMethod.html#ga065a8f8e5a28180fd0fa6d160e07481b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga1c3c2263d2bb2d250b1f926f4b4c1db5">minput_reset_ic</a> (<a class="el" href="structMInputContext.html">MInputContext</a> *ic)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Reset an input context.  <a href="group__m17nInputMethod.html#ga1c3c2263d2bb2d250b1f926f4b4c1db5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gaa6ca1639d1d2cc56908cc6972d237f3a">minput_get_title_icon</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get title and icon filename of an input method.  <a href="group__m17nInputMethod.html#gaa6ca1639d1d2cc56908cc6972d237f3a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nMtext.html#gae8bba45315c15c8f79ec4a73ebc52aec">MText</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga4a80b81791850c2445992e6e4fd7fa1b">minput_get_description</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get description text of an input method.  <a href="group__m17nInputMethod.html#ga4a80b81791850c2445992e6e4fd7fa1b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga4472e21e6a1e65056f5815c3ce36e41b">minput_get_command</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> name, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> command)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get information about input method command(s).  <a href="group__m17nInputMethod.html#ga4472e21e6a1e65056f5815c3ce36e41b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gaa5de29f63f6eb770059c2f55ce8237ed">minput_config_command</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> name, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> command, <a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *keyseqlist)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Configure the key sequence of an input method command.  <a href="group__m17nInputMethod.html#gaa5de29f63f6eb770059c2f55ce8237ed"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga09c8aea172323731cd3e946b3ef43a50">minput_get_variable</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> name, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> variable)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get information about input method variable(s).  <a href="group__m17nInputMethod.html#ga09c8aea172323731cd3e946b3ef43a50"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga15f7939874de15330d3d9aa0c450e424">minput_config_variable</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> name, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> variable, <a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *value)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Configure the value of an input method variable.  <a href="group__m17nInputMethod.html#ga15f7939874de15330d3d9aa0c450e424"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">char *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga5bf6821ca0d9bb5a738aba60225e247d">minput_config_file</a> ()</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get the name of per-user customization file.  <a href="group__m17nInputMethod.html#ga5bf6821ca0d9bb5a738aba60225e247d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga08b59a97ca5194abfb04dc4cc96919d6">minput_save_config</a> (void)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Save configurations in per-user customization file.  <a href="group__m17nInputMethod.html#ga08b59a97ca5194abfb04dc4cc96919d6"></a><br/></td></tr>
<tr><td colspan="2"><div class="groupHeader">Obsolete functions</div></td></tr>
<tr><td colspan="2"><div class="groupText"><p><a class="anchor" id="amgrpd7b632d1b5e66b7ba59ee87b8e389297"></a> </p>
</div></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gab6d3ebaf43705f994aebb990feada7aa">minput_get_variables</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get a list of variables of an input method (obsolete).  <a href="group__m17nInputMethod.html#gab6d3ebaf43705f994aebb990feada7aa"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gaec5679f07f92df8aba39e49fc90341bd">minput_set_variable</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> name, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> variable, void *value)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Set the initial value of an input method variable.  <a href="group__m17nInputMethod.html#gaec5679f07f92df8aba39e49fc90341bd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga63f6d2d105b01b7721f732b2433ea78e">minput_get_commands</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> name)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Get information about input method commands.  <a href="group__m17nInputMethod.html#ga63f6d2d105b01b7721f732b2433ea78e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga617c6a8028c05381f4f8a0ec781f1855">minput_assign_command_keys</a> (<a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> language, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> name, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> command, <a class="el" href="group__m17nPlist.html#gac8b2ac3c9a8f0a6afb7f189b694035e2">MPlist</a> *keyseq)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Assign a key sequence to an input method command (obsolete).  <a href="group__m17nInputMethod.html#ga617c6a8028c05381f4f8a0ec781f1855"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">int&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga955cd9e0b9fd8cf426aed3f3584337ff">minput_callback</a> (<a class="el" href="structMInputContext.html">MInputContext</a> *ic, <a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a> command)</td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Call a callback function.  <a href="group__m17nInputMethod.html#ga955cd9e0b9fd8cf426aed3f3584337ff"></a><br/></td></tr>
<tr><td colspan="2"><h2>Variables</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga4f2d5dc3e6c637d18e2ecf24edfff456">Minput_method</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">Symbol whose name is "input-method".  <a href="group__m17nInputMethod.html#ga4f2d5dc3e6c637d18e2ecf24edfff456"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structMInputDriver.html">MInputDriver</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gadb0ff8e5e616a810ed27113b17ad363b">minput_default_driver</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The default driver for internal input methods.  <a href="group__m17nInputMethod.html#gadb0ff8e5e616a810ed27113b17ad363b"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="structMInputDriver.html">MInputDriver</a> *&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga0e4d7a69ac0861d4b9b58990a0f03702">minput_driver</a></td></tr>
<tr><td class="mdescLeft">&nbsp;</td><td class="mdescRight">The driver for internal input methods.  <a href="group__m17nInputMethod.html#ga0e4d7a69ac0861d4b9b58990a0f03702"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gaf03ec92f0d20d9bff8b9031461270d41">Minput_driver</a></td></tr>
<tr><td colspan="2"><div class="groupHeader">Variables: Predefined symbols for callback commands.</div></td></tr>
<tr><td colspan="2"><div class="groupText"><p><a class="anchor" id="amgrp166ee6d4a07099967f73843ae890d3cf"></a> These are the predefined symbols that are used as the <code>COMMAND</code> argument of callback functions of an input method driver (see <a class="el" href="structMInputDriver.html#a159fe7401cd0913dc8c480a18efeff64" title="List of callback functions.">MInputDriver::callback_list</a>).</p>
<p>Most of them do not require extra argument nor return any value; exceptions are these:</p>
<p><b>Minput_get_surrounding_text:</b> When a callback function assigned for this command is called, the first element of <a class="el" href="structMInputContext.html#a12f494b6550e5ec675c187766fb9e461">MInputContext::plist</a> has key <a class="el" href="group__m17nPlist.html#ga0ce08eb57aa339db4d4745e75e80fdd8" title="Symbol whose name is &quot;integer&quot;.">Minteger</a> and the value specifies which portion of the surrounding text should be retrieved. If the value is positive, it specifies the number of characters following the current cursor position. If the value is negative, the absolute value specifies the number of characters preceding the current cursor position. If the value is zero, it means that the caller just wants to know if the surrounding text is currently supported or not.</p>
<p>If the surrounding text is currently supported, the callback function must set the key of this element to <a class="el" href="group__m17nPlist.html#ga1a22859374071a0ca66f12452afee8bd" title="Symbol whose name is &quot;mtext&quot;.">Mtext</a> and the value to the retrieved M-text. The length of the M-text may be shorter than the requested number of characters, if the available text is not that long. The length can be zero in the worst case. Or, the length may be longer if an application thinks it is more efficient to return that length.</p>
<p>If the surrounding text is not currently supported, the callback function should return without changing the first element of <a class="el" href="structMInputContext.html#a12f494b6550e5ec675c187766fb9e461">MInputContext::plist</a>.</p>
<p><b>Minput_delete_surrounding_text:</b> When a callback function assigned for this command is called, the first element of <a class="el" href="structMInputContext.html#a12f494b6550e5ec675c187766fb9e461">MInputContext::plist</a> has key <a class="el" href="group__m17nPlist.html#ga0ce08eb57aa339db4d4745e75e80fdd8" title="Symbol whose name is &quot;integer&quot;.">Minteger</a> and the value specifies which portion of the surrounding text should be deleted in the same way as the case of Minput_get_surrounding_text. The callback function must delete the specified text. It should not alter <a class="el" href="structMInputContext.html#a12f494b6550e5ec675c187766fb9e461">MInputContext::plist</a>. </p>
</div></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga5516535b28981c4b02b33368f3d56d56">Minput_preedit_start</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga3f96ecb6d7f7f82bc1ba5e47f8da0b92">Minput_preedit_done</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gacb0619c67c071d453dd2920ffc26d0ed">Minput_preedit_draw</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gad3739f8097f1c52f10a8581828b7bb95">Minput_status_start</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga49febb92bb4320bc27f20043517f3169">Minput_status_done</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gae75d45c1dbe0483768e9364af4d282f9">Minput_status_draw</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga6bb355b1b5521571056b96a854f3c6c8">Minput_candidates_start</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga6ff3deabad4489cef99fff428b2628e2">Minput_candidates_done</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga6bf782d7824557ec10e3988f6fcf4834">Minput_candidates_draw</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gaf19d77434bb1a12bdcb50f46448f1402">Minput_set_spot</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gafa306a028998a972bf3a05c8609fe65e">Minput_toggle</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga5f07520efe1e533af2b2322fca2bc9a2">Minput_reset</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga1ca3d6e04f44fada82ed3c81069be23c">Minput_get_surrounding_text</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gab1bfef46ab8e9daa6f3cf53b912b7da8">Minput_delete_surrounding_text</a></td></tr>
<tr><td colspan="2"><div class="groupHeader">Variables: Predefined symbols for special input events.</div></td></tr>
<tr><td colspan="2"><div class="groupText"><p><a class="anchor" id="amgrpc0c39849c0524dad7976cd7838b37822"></a> These are the predefined symbols that are used as the <code>KEY</code> argument of <a class="el" href="group__m17nInputMethod.html#ga6d9c3c97524114496fd8b7f70af92457" title="Filter an input key.">minput_filter()</a>. </p>
</div></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga3edb37986f3bcdd15d73884c0d9b239b">Minput_focus_out</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga0d721c64e73c1e362f3cc44716b6c6ab">Minput_focus_in</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga2b2dd61bcb633e89865ebeda1cd9f466">Minput_focus_move</a></td></tr>
<tr><td colspan="2"><div class="groupHeader">Variables: Predefined symbols used in input method information.</div></td></tr>
<tr><td colspan="2"><div class="groupText"><p><a class="anchor" id="amgrp38f97959bd3288443b767410964595f4"></a> </p>
</div></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gaf84d56e3015c4b26802debcbd9352806">Minherited</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#ga07679cd0d5bf8e137d5dc554a30aa106">Mcustomized</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__m17nSymbol.html#ga0f53a95817f0b5c26442f8e12f89c16d">MSymbol</a>&nbsp;</td><td class="memItemRight" valign="bottom"><a class="el" href="group__m17nInputMethod.html#gae01597fe66dfef937b4c5c47e54abbd0">Mconfigured</a></td></tr>
</table>
</div>
<!--- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&nbsp;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&nbsp;</span>Data Structures</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&nbsp;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&nbsp;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&nbsp;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&nbsp;</span>Typedefs</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&nbsp;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&nbsp;</span>Enumerator</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(8)"><span class="SelectionMark">&nbsp;</span>Defines</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<hr>

<ADDRESS>
<a href="http://www.m17n.org/m17n-lib-en/index.html" target="mulewindow"><img src="parrot.png" align=bottom alt="m17n-lib Home" border=0></a>
</ADDRESS>
</body>
</HTML>

<!-- Copyright information

Copyright (C) 2001 Information-technology Promotion Agency (IPA)
Copyright (C) 2001-2011
  National Institute of Advanced Industrial Science and Technology (AIST)

This file is part of the m17n library documentation.

Permission is granted to copy, distribute and/or modify this document
under the terms of the GNU Free Documentation License, Version 1.2 or
any later version published by the Free Software Foundation; with no
Invariant Section, no Front-Cover Texts,
and no Back-Cover Texts.  A copy of the license is included in the
appendix entitled "GNU Free Documentation License".
-->
